#
# -*- coding: cp932 -*-
# Above line is to get rid of warning that this file contains non-ascii
# More specifically, it is shift-jis
#
# Jan-29-07: CINCIN
#    Fixed Color Map
#    Removed Defrag2, instead color original text
# Jan-28-07: CINCIN
#    Initial

from Tkinter import *
from string import *
import sys

class defragi_san_gui:
   def __init__(self, root):

      root.title('defrag-san')
      root.resizable(width = FALSE, height = FALSE)

   # Override print, direct any print to here
   #   sys.stdout = self

   # Create entry 
      parent = Frame(root)
      parent.pack()
      frent = Frame(parent)

      but = Button(frent, text=unicode("[߄t]","cp932"))
      but.grid(row=0, column=1, sticky=SE, padx=10)
      but.bind('<ButtonRelease-1>', self.StartCallBack)

      frent.pack(anchor="se")
      frent.pack()

   # Create output
      scrollbar = Scrollbar(parent)
      scrollbar.pack(side=RIGHT, fill=Y)

      self.txt = Text(parent, yscrollcommand=scrollbar.set)
      self.txt.pack(padx = 5, pady= 5, side= RIGHT)
      self.txt.configure(state = DISABLED)

      scrollbar.config(command=self.txt.yview)
      scrollbar.config(command=self.txt.yview)

   # Create input field
      scrollbar = Scrollbar(parent)
      scrollbar.pack(side=RIGHT, fill=Y)

      self.edt = Text(parent, yscrollcommand=scrollbar.set)
      self.edt.pack(padx = 5, pady = 5, side= LEFT)

      scrollbar.config(command=self.edt.yview)
      scrollbar.config(command=self.edt.yview)

      parent.pack()

   def StartCallBack(self, evt):
      res = self.edt.get(1.0, END)
      self.DoDefrag(res)

   def write(self, str, tag = None):
      if str != "\n":
         self.stat.config(text=str)
         self.stat.update_idletasks()

   def AddText(self, text, tag = None):
      self.txt.configure(state = NORMAL)
      self.txt.insert(END, text, tag)
      self.txt.configure(state = DISABLED)

   def ClearText(self):
      # Clear widget
      self.txt.configure(state = NORMAL)
      self.txt.delete(1.0, END)
      self.txt.configure(state = DISABLED)

   def Defrag(self, text):
      # Store in dict usint each text as hash key
      result = {}
      for ii in range (len(text)):
         if text[ii] == u'\n':
            pass 
         elif result.has_key(text[ii]):
            result[text[ii]] = result[text[ii]] + 1 
         else:
            result[text[ii]] = 1 
      return result

   def DoDefrag(self, text):
      self.ClearText()
      self.AddText(unicode("@@@[ ߄t]y-~~~~~\n @@@/[ւ\n", "cp932"))

      result = self.Defrag(text)

      # Sort the key and format Output widget
      keys = result.keys()
      keys.sort()
      for key in keys:
         dtext = key * result[key]
         self.txt.tag_add(key,END)
         val = self.mapColor(result[key] - 1)
         self.txt.tag_config(key, background='#%06X' % val)
         self.AddText(dtext,key)

      # Add color to input
      col = 0
      row = 1
      for ii in range(len(text)):
         key = text[ii]
         if key == u"\n" or result[key] <= 1:
         # FIXME: Get the back ground of text
            self.edt.tag_add(u'NoCol','%d.%d' % (row, col))
            self.edt.tag_config(u'NoCol', background='white')
            if key == '\n':
               row = row + 1
               col = -1    # Kludge to set -1 so next will be 0
         else:
            val = self.mapColor(result[key] - 1)
            self.edt.tag_add(key,'%d.%d' % (row, col))
            self.edt.tag_config(key, background='#%06X' % val)
         col = col + 1

   def mapColor(self, col):
      # Calculate color:
      off = 32   # difference per color
      val = 0x010101 * off * (col / 8)
      if col & 1:
         val = val + 1 * off
      if col & 2:
         val = val + 0x100 * off
      if col & 4:
         val = val + 0x10000 * off
      val = val ^ 0xFFFFFF
      return val

def main():
  root = Tk()
  t = defragi_san_gui(root)
  root.mainloop()

# Run program when run as a script
if __name__ == '__main__':
    main()

